package it.unipd.stat.se2;

public class StackObject
{
	private Object[] storage;
	private int size;

	public StackObject(int theSize) //throws StackException
	{
		if(theSize < 0)
		{
			throw new StackException("Non si puo' construire uno stack che contenga al massimo " + theSize + " elementi");
		}
		storage = new Object[theSize];
		this.size = 0;
	}

	public void push(Object elem)
	{
		/*
		storage[size] = elem;
		size++;
		*/

		if(size == storage.length)
		{
			throw new StackException("Stack pieno: " + size + " elementi");
		}

		try
		{
			storage[size++] = elem;
		}
		catch(ArrayIndexOutOfBoundsException aioobe)
		{
			StackException se = new StackException("Stack pieno: " + size + " elementi", aioobe);
			throw se;
		}
	}

	public Object pop()
	{
		/*
		int retval;
		retval = storage[size-1];
		size = size-1;
		return retval;
		*/
		if(isEmpty())
		{
			throw new StackException("Stack vuoto");
		}
		return storage[--size];
	}

	public Object top()
	{
		if(isEmpty())
		{
			throw new StackException("Stack vuoto");
		}
		return storage[size-1];
	}

	public boolean isEmpty()
	{
		return size == 0;
	}

	public int size()
	{
		return size;
	}

	public String toString()
	{
		String retval = "[";
		//String tmp;
		int i = size-1;
		while(i >= 0)
		{
			//retval.concat(", " + storage[i--]); non funziona, non ha effetti collaterali
			// questo sarebbe necessario in un linguaggio con gestion esplicita della memoria, e.g. C, C++
			/*
			tmp = retval.concat(storage[i--] + ", ");
			free(retval);
			retval = tmp;
			*/

			//in Java e' sufficiente, la garbage collection si occupa di reclamare la memoria non piu' in uso
			retval = retval.concat(storage[i--] + ", ");
		}
		retval += "]";
		return retval;
	}
}
